class TheCatTools.GUI.Bubble : DrawingAreaOrientable {
    public double value_x { get; set; default = 0; }
    public double value_y { get; set; default = 0; }
    public double radius { get; set; default = 20; }
    public Gtk.Adjustment adjustment { get; set; default = new Gtk.Adjustment (0, -90, 90, 0, 0, 0); }

    construct {
        add_css_class ("bubble");
        this.notify["value-x"].connect (queue_draw);
        this.notify["value-y"].connect (queue_draw);
    }

    double clamped (double value) {
        var res = value * -1;
        if (res > 90)
            res = 180 - res;
        if (res < -90)
            res = -180 - res;
        return res.clamp (adjustment.lower, adjustment.upper);
    }

    public override void draw_func (Gtk.DrawingArea self, Cairo.Context cr, int width, int height) {
        var val_x = clamped (value_x);
        var val_y = clamped (value_y);
        var range = adjustment.upper - adjustment.lower;
        var position_y = radius + (height - 2 * radius) * (val_x - adjustment.lower) / range;
        var position_x = radius + (width - 2 * radius) * (val_y - adjustment.lower) / range;
        Utils.set_color_rgba (cr, get_color ());
        cr.arc (position_x, position_y, radius, 0, Math.PI * 2);
        cr.fill ();
    }
}