abstract class TheCatTools.GUI.DrawingAreaOrientable : Gtk.DrawingArea, Gtk.Orientable {
    public Gtk.Orientation orientation { get; set; }

    construct {
        set_draw_func (_sdraw_func);
    }


    private void _sdraw_func (Gtk.DrawingArea self, Cairo.Context cr, int width, int height) {
        if (orientation == Gtk.Orientation.HORIZONTAL) {
            cr.rotate (Math.PI / 2);
            cr.translate (0, -width);
            draw_func (self, cr, height, width);
        } else {
            draw_func (self, cr, width, height);
        }
    }

    public abstract void draw_func (Gtk.DrawingArea self, Cairo.Context cr, int width, int height);
}